Instructions for [TP-Link TL-MR3020 v1](https://openwrt.org/toh/tp-link/tl-mr3020)

Based on [OpenWrt Hello World guide](https://openwrt.org/docs/guide-developer/helloworld/start)

You are supposed to be running **Ubuntu 22.04 LTS** with a home directory at `/home/vboxuser` (Update paths below and `ogspkg/games/ogs-memory/Makefile` if your home directory is different)

1. Install necessary dependencies:
    ```
	apt install libtinfo5 gawk
1. Place this Memory game repository clone to `~/research-portable-memory`
1. Download the last supported [SDK 17.01.7](https://downloads.openwrt.org/releases/17.01.7/targets/ar71xx/generic/lede-sdk-17.01.7-ar71xx-generic_gcc-5.4.0_musl-1.1.16.Linux-x86_64.tar.xz)
1. Unpack it to `~/openwrt-sdk`:
	```
	tar -xf lede-sdk-17.01.7-ar71xx-generic_gcc-5.4.0_musl-1.1.16.Linux-x86_64.tar.xz
	mv lede-sdk-17.01.7-ar71xx-generic_gcc-5.4.0_musl-1.1.16.Linux-x86_64 ~/openwrt-sdk
1. Create `feeds.conf` pointing to `ogspkg`:
	```
	echo 'src-link ogspkg /home/vboxuser/research-portable-memory/platform-OpenWrt/ogspkg' > ~/openwrt-sdk/feeds.conf
1. Update feeds:
	```
	~/openwrt-sdk/scripts/feeds update ogspkg
	~/openwrt-sdk/scripts/feeds install -a -p ogspkg
1. Run `make menuconfig` from `openwrt-sdk`
1. Make sure `Games -> ogs-memory` is selected as Module <M>, `Save` if necessary
1. Build the package:
	```
	cd ~/openwrt-sdk
	make package/ogs-memory/compile
1. Transfer built `~/openwrt-sdk/bin/packages/ogspkg/ogs-memory-xxx???.ipk` to `/tmp` on the device with OpenWrt
1. Install package to device's RAM:
	```
	opkg install /tmp/ogs-memory-xxx???.ipk -d ram
1. Run `ogs-memory`:
    ```
    LD_LIBRARY_PATH=/tmp/usr/lib /tmp/usr/bin/ogs-memory
